using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using System.Xml;

using System.Linq;

using Scurvy;
using Scurvy.Media;
using Scurvy.Media.VideoModel;
using Scurvy.Media.Audio;

//Classe Principale del progetto
//Gestisce l'intero workflow del gioco
namespace TheGame
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        #region VARS
        int MAXlvls = 3;
        public int NUMLVLGEN = 0;
        public bool SHOW_REPORT = false;
        public Report REPORT;
        bool Debug = false;
        public Rectangle backRec;
        public Rectangle sourceRect;
        public Texture2D spriteCurrent;
        public Texture2D background;
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        float timer = 0f;
        float FRAME_RATE = 1000 / 30;
        public bool rightDown = false;
        public bool leftDown = false;
        public bool upDown = false;
        public bool downDown = false;
        public bool spaceDown = false;
        public bool shiftDown = false;
        public bool altDown = false;
        public bool zetaDown = false;

        public bool rightDownSlig = false;
        public bool leftDownSlig = false;
        public bool OnerightDownSlig = false;
        public bool OneleftDownSlig = false;

        float OnepassSligg = 0f;

        bool PAUSE = false;
        int screenWidth;
        int screenHeight;
        bool F11firstDown = true;
        bool F10firstDown = true;
        bool TABfirstDown = true;
        public bool OneDown = false;
        public bool TwoDown = false;
        public bool ThreeDown = false;
        public bool FourDown = false;
        public bool ZeroDown = false;
        public bool CTRLDown = false;
        public bool FirstCTRLDown = true;
        int frames = 30;
        public MudokonFactory MudokonFactory;
        public Abe Abe;
        public SligFactory SligFactory;
        public AbeControl abeCONTROL;
        Level currentLevel;     
        bool drawBack = true;
        List<string> colTypes;
        public ObjectA LEVA;
        public ObjectA BOTOLA;
        public ObjectA MATTATOIO;
        public bool IsPORTALOPEN = false;
        ContentManager VideoContent;
        #endregion

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            colTypes = new List<string>();
            VideoContent = new VideoContentManager(Services);
            VideoContent.RootDirectory = "Content";
        }
        
        //Vengono settate alcune impostazioni del sistema
        //[p.21]
        protected override void Initialize()
        {
            this.graphics.PreferredBackBufferWidth = 640;
            this.graphics.PreferredBackBufferHeight = 480;
            graphics.ApplyChanges();
            screenWidth = graphics.GraphicsDevice.Viewport.Width;
            screenHeight = graphics.GraphicsDevice.Viewport.Height;
            base.Initialize();
        }

        //Vengono caricate le risorse del gioco (sprites, suoni, video)
        //[p.22]
        protected override void LoadContent()
        {
            REPORT = new Report(this);
            MudokonFactory = new MudokonFactory(this);
            SligFactory = new SligFactory(this);
            LevelMaker vlv = new LevelMaker(this);            
            Abe = new Abe(this);  
            abeCONTROL = new AbeControl(Abe, this);          
            foreach(Video vid in currentLevel.VIDEOS)
                vid.Play();           

            spriteBatch = new SpriteBatch(GraphicsDevice);        
            spriteCurrent = Abe.CurrentAnimation.Sheet;
                      
            backRec = new Rectangle(0, 0, 640, 480);           
        }

        //Chiamato a fine sondaggio
        //I riferimenti ai livelli generati vengono eliminati
        public void ReInit()
        {
            CurrentLevel = LevelMaker.lvlList[0];
            currentLevel.compatibleLevels.Clear();
            currentLevel.NextRIGHT = null;
            currentLevel.NextDOWN = null;

            Abe = new Abe(this);
            abeCONTROL = new AbeControl(Abe, this);

            #region DEMO
            /////////////////////////////////////////////////////
            Level la;
            Level lb;

            REPORT.LEVELS.Clear();
            lb = new Level(getLevel("R1P15C02"));
            LevelMaker.lvlList[0].NextRIGHT = lb;
            lb.NextLEFT = LevelMaker.lvlList[0];

            //la = lb;
            //lb = new Level(getLevel("R1P16C03"));
            //REPORT.LEVELS.Add(la);
            //la.NextRIGHT = lb;
            //lb.NextLEFT = la;

            //la = lb;
            //lb = new Level(getLevel("R1P16C06"));
            //REPORT.LEVELS.Add(la);
            //la.NextRIGHT = lb;
            //lb.NextLEFT = la;

            //la = lb;
            //lb = new Level(getLevel("R1P18C02"));
            //REPORT.LEVELS.Add(la);
            //la.NextRIGHT = lb;
            //lb.NextLEFT = la;

            //la = lb;
            //lb = new Level(getLevel("R1P18C11"));
            //REPORT.LEVELS.Add(la);
            //la.NextRIGHT = lb;
            //lb.NextLEFT = la;

            //la = lb;
            //lb = new Level(getLevel("R1P18C03"));
            //REPORT.LEVELS.Add(la);
            //la.NextRIGHT = lb;
            //lb.NextLEFT = la;

            //la = lb;
            //lb = new Level(getLevel("R1P16C02"));
            //REPORT.LEVELS.Add(la);
            //la.NextRIGHT = lb;
            //lb.NextLEFT = la;


            ///////////////////////////////////////// 
            #endregion

            foreach (Video vid in currentLevel.VIDEOS)
                vid.Play();
        }

        //Chiamato quando il personaggio muore
        //Riavvia il gioco dal primo livello senza eliminare i riferimenti ai livelli generati
        public void ReStart()
        {
            CurrentLevel = LevelMaker.lvlList[0];

            Abe = new Abe(this);
            abeCONTROL = new AbeControl(Abe, this);

            #region DEMO
            /////////////////////////////////////////////////////
            Level la;
            Level lb;

            REPORT.LEVELS.Clear();
            lb = new Level(getLevel("R1P15C02"));
            LevelMaker.lvlList[0].NextRIGHT = lb;
            lb.NextLEFT = LevelMaker.lvlList[0];

            la = lb;
            lb = new Level(getLevel("R1P16C03"));
            REPORT.LEVELS.Add(la);
            la.NextRIGHT = lb;
            lb.NextLEFT = la;

            la = lb;
            lb = new Level(getLevel("R1P16C06"));
            REPORT.LEVELS.Add(la);
            la.NextRIGHT = lb;
            lb.NextLEFT = la;

            la = lb;
            lb = new Level(getLevel("R1P18C02"));
            REPORT.LEVELS.Add(la);
            la.NextRIGHT = lb;
            lb.NextLEFT = la;

            la = lb;
            lb = new Level(getLevel("R1P18C11"));
            REPORT.LEVELS.Add(la);
            la.NextRIGHT = lb;
            lb.NextLEFT = la;

            la = lb;
            lb = new Level(getLevel("R1P18C03"));
            REPORT.LEVELS.Add(la);
            la.NextRIGHT = lb;
            lb.NextLEFT = la;

            la = lb;
            lb = new Level(getLevel("R1P16C02"));
            REPORT.LEVELS.Add(la);
            la.NextRIGHT = lb;
            lb.NextLEFT = la;


            ///////////////////////////////////////// 
            #endregion
            foreach (Level lvl in REPORT.LEVELS)
                lvl.RESET();

            foreach (Video vid in currentLevel.VIDEOS)
                vid.Play();
        }

        //La memoria viene liberate dalle risorse caricate
        //[p.22]
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }


        //Aggiorna lo stato del sistema
        //Frame rate impostato a 30fps
        //[p.22]
        protected override void Update(GameTime gameTime)
        {
            //Aggiorna i frame delle animazioni
            #region FrameUpdate
            float deltaTime = (float)gameTime.ElapsedGameTime.TotalMilliseconds;
            float deltaTime2 = (float)gameTime.ElapsedGameTime.TotalMilliseconds;
            timer += deltaTime;

            Abe.JUMPUP.Time += deltaTime;
            Abe.JUMPDOWN.Time += deltaTime;

            Abe.PASS_1.Time += deltaTime;
            Abe.PASS_2.Time += deltaTime;
            Abe.PASS_3.Time += deltaTime;
            Abe.STOP.Time += deltaTime;

            Abe.WAIT.Time += deltaTime;
            Abe.TURN.Time += deltaTime;
            Abe.HUNG.Time += deltaTime;
            Abe.HUNGLONG.Time += deltaTime;
            Abe.PLANE.Time += deltaTime;
            Abe.GODOWN.Time += deltaTime;

            Abe.JUMP_1.Time += deltaTime;
            Abe.JUMP_2.Time += deltaTime;
            Abe.JUMP_3.Time += deltaTime;
            Abe.JUMP_4.Time += deltaTime;

            Abe.KO.Time += deltaTime;
            Abe.GETUP.Time += deltaTime;
            Abe.RUN_1.Time += deltaTime;
            Abe.RUN_2.Time += deltaTime;
            Abe.RUN_3.Time += deltaTime;
            Abe.RUN_4.Time += deltaTime;
            Abe.RUN_5.Time += deltaTime;

            Abe.HOISTUP.Time += deltaTime;
            Abe.HOISTDOWN.Time += deltaTime;

            Abe.BLOCK.Time += deltaTime;
            Abe.WAITcROUCH.Time += deltaTime;
            Abe.CROUCH.Time += deltaTime;
            Abe.STANDUP.Time += deltaTime;
            Abe.TURNdOWN.Time += deltaTime;
            Abe.ROLL1.Time += deltaTime;
            Abe.ROLL2.Time += deltaTime;
            Abe.ROLL3.Time += deltaTime;

            Abe.RUNsTOP_1.Time += deltaTime;
            Abe.RUNsTOP_2.Time += deltaTime;

            Abe.RUNJUMP1.Time += deltaTime;
            Abe.RUNJUMP2.Time += deltaTime;
            Abe.RUNJUMP3.Time += deltaTime;
            Abe.RUNJUMP4.Time += deltaTime;

            Abe.SNEAK_1.Time += deltaTime;
            Abe.SNEAK_2.Time += deltaTime;
            Abe.SNEAK_3.Time += deltaTime;
            Abe.SNEAKsTOP.Time += deltaTime;

            Abe.HELLO.Time += deltaTime;
            Abe.FOLLOW.Time += deltaTime;
            Abe.WAITME.Time += deltaTime;
            Abe.COMMANDJUMP.Time += deltaTime;
            Abe.COMMANDRUNJUMP.Time += deltaTime;

            Abe.DIE.Time += deltaTime;
            Abe.ENTERDOOR.Time += deltaTime;
            Abe.EXITDOOR.Time += deltaTime;

            Abe.PULLEVER.Time += deltaTime;
            Abe.BOMBDEACTIVATE.Time += deltaTime;
            Abe.BOMBDEACTIVATEFAIL.Time += deltaTime;
            Abe.BOMBEXPLODE.Time += deltaTime;
            Abe.OMM.Time += deltaTime;
            Abe.NOTCONTROL.Time += deltaTime;

            if (Abe.DEAD & abeCONTROL.CURRENT_STATE.name == "DIED" & abeCONTROL.CURRENT_STATE.ENDSTATE)
                ReStart();
            foreach (Slig slig in currentLevel.Sligs)
            {
                if (!Abe.SLIGS.Contains(slig))
                {
                    slig.ONEPASS.Time += deltaTime;
                    slig.PASS1.Time += deltaTime;
                    slig.PASS2.Time += deltaTime;
                    slig.PASS3.Time += deltaTime;
                    slig.TURN.Time += deltaTime;
                    slig.START.Time += deltaTime;
                    slig.PASSsTOP.Time += deltaTime;
                    slig.WAIT.Time += deltaTime;
                    slig.SHOOT.Time += deltaTime;
                    slig.SHOOTsTART.Time += deltaTime;
                    slig.SHOOTsTOP.Time += deltaTime;
                    slig.RUN1.Time += deltaTime;
                    slig.RUN2.Time += deltaTime;
                    slig.RUN3.Time += deltaTime;
                    slig.RUN4.Time += deltaTime;
                    slig.RUNsTART.Time += deltaTime;
                    slig.RUNsTOP1.Time += deltaTime;
                    slig.RUNsTOP2.Time += deltaTime;
                    slig.SLEEP.Time += deltaTime;
                    slig.WAKE.Time += deltaTime;
                    slig.WHAAT.Time += deltaTime;
                    slig.FREEZE.Time += deltaTime;
                    slig.SPLAT.Time += deltaTime;
                    slig.DOWNPLANE.Time += deltaTime;
                    slig.POSSESSED.Time += deltaTime;
                    slig.JUSTPOSSESSED.Time += deltaTime;
                    slig.SUICIDE.Time += deltaTime;
                    slig.OUCH.Time += deltaTime;
                    slig.HEELP.Time += deltaTime;
                }
            }


            foreach (Slig slig in Abe.SLIGS)
            {
                slig.ONEPASS.Time += deltaTime;
                slig.PASS1.Time += deltaTime;
                slig.PASS2.Time += deltaTime;
                slig.PASS3.Time += deltaTime;
                slig.TURN.Time += deltaTime;
                slig.START.Time += deltaTime;
                slig.PASSsTOP.Time += deltaTime;
                slig.WAIT.Time += deltaTime;
                slig.SHOOT.Time += deltaTime;
                slig.SHOOTsTART.Time += deltaTime;
                slig.SHOOTsTOP.Time += deltaTime;
                slig.RUN1.Time += deltaTime;
                slig.RUN2.Time += deltaTime;
                slig.RUN3.Time += deltaTime;
                slig.RUN4.Time += deltaTime;
                slig.RUNsTART.Time += deltaTime;
                slig.RUNsTOP1.Time += deltaTime;
                slig.RUNsTOP2.Time += deltaTime;
                slig.SLEEP.Time += deltaTime;
                slig.WAKE.Time += deltaTime;
                slig.WHAAT.Time += deltaTime;
                slig.FREEZE.Time += deltaTime;
                slig.SPLAT.Time += deltaTime;
                slig.DOWNPLANE.Time += deltaTime;
                slig.POSSESSED.Time += deltaTime;
                slig.JUSTPOSSESSED.Time += deltaTime;
                slig.SUICIDE.Time += deltaTime;
                slig.OUCH.Time += deltaTime;
                slig.HEELP.Time += deltaTime;
            }



            foreach (Mudokon mudokon in currentLevel.Mudokons)
            {
                if (!Abe.MUDOKONS.Contains(mudokon))
                {
                    mudokon.WAIT.Time += deltaTime;
                    mudokon.SNEAK_1.Time += deltaTime;
                    mudokon.SNEAK_2.Time += deltaTime;
                    mudokon.SNEAK_3.Time += deltaTime;
                    mudokon.SNEAKsTOP.Time += deltaTime;
                    mudokon.RUN_1.Time += deltaTime;
                    mudokon.RUN_2.Time += deltaTime;
                    mudokon.RUN_3.Time += deltaTime;
                    mudokon.RUN_4.Time += deltaTime;
                    mudokon.RUN_5.Time += deltaTime;
                    mudokon.RUNsTOP_1.Time += deltaTime;
                    mudokon.RUNsTOP_2.Time += deltaTime;
                    mudokon.RUNJUMP1.Time += deltaTime;
                    mudokon.RUNJUMP2.Time += deltaTime;
                    mudokon.RUNJUMP3.Time += deltaTime;
                    mudokon.RUNJUMP4.Time += deltaTime;
                    mudokon.STOP.Time += deltaTime;
                    mudokon.PASS_1.Time += deltaTime;
                    mudokon.PASS_2.Time += deltaTime;
                    mudokon.PASS_3.Time += deltaTime;
                    mudokon.TURN.Time += deltaTime;
                    mudokon.HELLO.Time += deltaTime;
                    mudokon.OK.Time += deltaTime;
                    mudokon.WAITcROUCH.Time += deltaTime;
                    mudokon.STANDUP.Time += deltaTime;
                    mudokon.CROUCH.Time += deltaTime;
                    mudokon.DIE.Time += deltaTime;
                    mudokon.PLANE.Time += deltaTime;
                    mudokon.GODOWN.Time += deltaTime;
                    mudokon.CLEANUP.Time += deltaTime;
                    mudokon.RESTUP.Time += deltaTime;
                    mudokon.CLEANUPSTOPLEFT.Time += deltaTime;
                    mudokon.CLEANUPSTOPRIGHT.Time += deltaTime;
                    mudokon.TURNdOWN.Time += deltaTime;
                    mudokon.CLEANDOWN.Time += deltaTime;
                    mudokon.JUMP_1.Time += deltaTime;
                    mudokon.JUMP_2.Time += deltaTime;
                    mudokon.JUMP_3.Time += deltaTime;
                    mudokon.JUMP_4.Time += deltaTime;
                    mudokon.HOISTUP.Time += deltaTime;
                    mudokon.HOISTDOWN.Time += deltaTime;
                    mudokon.JUMPUP.Time += deltaTime;
                    mudokon.JUMPDOWN.Time += deltaTime;
                    mudokon.KO.Time += deltaTime;
                    mudokon.GETUP.Time += deltaTime;

                }
            }

            for (int i = 1; i < Abe.MUDOKONS.Count; i++)
            {
                Mudokon mudokon = (Mudokon)Abe.MUDOKONS[i];

                mudokon.WAIT.Time += deltaTime;
                mudokon.SNEAK_1.Time += deltaTime;
                mudokon.SNEAK_2.Time += deltaTime;
                mudokon.SNEAK_3.Time += deltaTime;
                mudokon.SNEAKsTOP.Time += deltaTime;
                mudokon.RUN_1.Time += deltaTime;
                mudokon.RUN_2.Time += deltaTime;
                mudokon.RUN_3.Time += deltaTime;
                mudokon.RUN_4.Time += deltaTime;
                mudokon.RUN_5.Time += deltaTime;
                mudokon.RUNsTOP_1.Time += deltaTime;
                mudokon.RUNsTOP_2.Time += deltaTime;
                mudokon.RUNJUMP1.Time += deltaTime;
                mudokon.RUNJUMP2.Time += deltaTime;
                mudokon.RUNJUMP3.Time += deltaTime;
                mudokon.RUNJUMP4.Time += deltaTime;
                mudokon.STOP.Time += deltaTime;
                mudokon.PASS_1.Time += deltaTime;
                mudokon.PASS_2.Time += deltaTime;
                mudokon.PASS_3.Time += deltaTime;
                mudokon.TURN.Time += deltaTime;
                mudokon.HELLO.Time += deltaTime;
                mudokon.OK.Time += deltaTime;
                mudokon.WAITcROUCH.Time += deltaTime;
                mudokon.STANDUP.Time += deltaTime;
                mudokon.CROUCH.Time += deltaTime;
                mudokon.DIE.Time += deltaTime;
                mudokon.PLANE.Time += deltaTime;
                mudokon.GODOWN.Time += deltaTime;
                mudokon.CLEANUP.Time += deltaTime;
                mudokon.RESTUP.Time += deltaTime;
                mudokon.CLEANUPSTOPLEFT.Time += deltaTime;
                mudokon.CLEANUPSTOPRIGHT.Time += deltaTime;
                mudokon.TURNdOWN.Time += deltaTime;
                mudokon.CLEANDOWN.Time += deltaTime;
                mudokon.JUMP_1.Time += deltaTime;
                mudokon.JUMP_2.Time += deltaTime;
                mudokon.JUMP_3.Time += deltaTime;
                mudokon.JUMP_4.Time += deltaTime;
                mudokon.HOISTUP.Time += deltaTime;
                mudokon.HOISTDOWN.Time += deltaTime;
                mudokon.JUMPUP.Time += deltaTime;
                mudokon.JUMPDOWN.Time += deltaTime;
                mudokon.KO.Time += deltaTime;
                mudokon.GETUP.Time += deltaTime;

            }

            foreach (ObjectA OBJ in currentLevel.ObjectsA)
            {
                if (OBJ.PORTALDEFAULT != null)
                    OBJ.PORTALDEFAULT.Time += deltaTime;
                if (OBJ.PORTALFLYAWAY != null)
                    OBJ.PORTALFLYAWAY.Time += deltaTime;
                if (OBJ.PORTALOPENING != null)
                    OBJ.PORTALOPENING.Time += deltaTime;
                if (OBJ.PORTALOPEN != null)
                    OBJ.PORTALOPEN.Time += deltaTime;
                if (OBJ.DEFAULT != null)
                    OBJ.DEFAULT.Time += deltaTime;
                if (OBJ.ACTIVATED != null)
                    OBJ.ACTIVATED.Time += deltaTime;
            }

            foreach (Video vid in currentLevel.VIDEOS)
                vid.Update(); 
            #endregion

            //Rileva comandi secondari
            #region SystemCommand
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            if (Keyboard.GetState().IsKeyDown(Keys.Escape))//EXIT
                this.Exit();

            if (Keyboard.GetState().IsKeyDown(Keys.PageUp) & frames < 33)//frame up
            {
                //PageUpfirstDown = false;
                frames += 1;
                FRAME_RATE = 1000 / frames;
            }
            if (Keyboard.GetState().IsKeyUp(Keys.PageUp))
                //PageUpfirstDown = true;

                if (Keyboard.GetState().IsKeyDown(Keys.PageDown) & frames > 1)//frame down
                {
                    //PageDownfirstDown = false;
                    frames -= 1;
                    FRAME_RATE = 1000 / frames;
                }
            if (Keyboard.GetState().IsKeyUp(Keys.PageDown))
                //PageDownfirstDown = true;

                if (Keyboard.GetState().IsKeyDown(Keys.F11) & F11firstDown)//FULLSCREEN/WINDOW
                {
                    F11firstDown = false;
                    this.graphics.IsFullScreen = !this.graphics.IsFullScreen;
                    graphics.ApplyChanges();
                }
            if (Keyboard.GetState().IsKeyUp(Keys.F11))
                F11firstDown = true;


            if (Keyboard.GetState().IsKeyDown(Keys.F1) & F10firstDown)//DRAW BACKGROUND
            {
                F10firstDown = false;
                drawBack = !drawBack;
            }
            if (Keyboard.GetState().IsKeyUp(Keys.F1))
                F10firstDown = true;

            if (Keyboard.GetState().IsKeyDown(Keys.Tab) & TABfirstDown)//DRAW DEBUG
            {
                TABfirstDown = false;
                Debug = !Debug;
            }
            if (Keyboard.GetState().IsKeyUp(Keys.Tab))
                TABfirstDown = true;
            
            #endregion

            if (timer >= FRAME_RATE)
            {
                timer = 0f;

                //Gestione uscita dal livello corrente (Abe)
                //Se Abe esce dal livello corrente ne viene generato uno nuovo.
                #region ABEChangeLevel
                if (Abe.BoundigBox.X >= 640 & Abe.CurrentAnimation.LastFrameDone)
                {
                    if (currentLevel.NextRIGHT == null)
                    {
                        currentLevel.NextRIGHT = getNextLvl(currentLevel, GetNextCompLevels(currentLevel, "RIGHT"));
                        currentLevel.NextRIGHT.NextLEFT = currentLevel;
                    }
                    Abe.BoundigBox = new Rectangle(6, Abe.BoundigBox.Y, Abe.BoundigBox.Width, Abe.BoundigBox.Height);
                    Abe.DrawingRec.X -= 640 + 5;

                    ResetVideos(Abe, currentLevel.NextRIGHT);

                    for (int i = 0; i < currentLevel.Sligs.Count; i++)
                    {
                        if (!Abe.SLIGS.Contains(currentLevel.Sligs[i]))
                            currentLevel.Sligs[i].AI.CURRENT_STATE.RESET();
                    }
                    for (int i = 1; i < Abe.MUDOKONS.Count; i++)
                    {
                        if (Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITCOMMAND || Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITfOLLOW)
                            Abe.MUDOKONS[i].AI.CURRENT_STATE = Abe.MUDOKONS[i].AI.CLEANDOWN;
                    }
                    foreach (ObjectA OBj in currentLevel.ObjectsA)
                    {
                        if (OBj.NAME == "PORTAL")
                            OBj.objControl.CURRENT_STATE = OBj.objControl.PORTALDEFAULT;
                    }
                }
                if (Abe.BoundigBox.X < 6 & Abe.CurrentAnimation.LastFrameDone)
                {
                    if (currentLevel.NextLEFT == null)
                    {
                        currentLevel.NextLEFT = getNextLvl(currentLevel, GetNextCompLevels(currentLevel, "LEFT"));
                        currentLevel.NextLEFT.NextRIGHT = currentLevel;
                    }

                    Abe.BoundigBox = new Rectangle(6 + 43 * 14, Abe.BoundigBox.Y, Abe.BoundigBox.Width, Abe.BoundigBox.Height);
                    Abe.DrawingRec.X += 640 + 5;

                    ResetVideos(Abe, currentLevel.NextLEFT);

                    for (int i = 0; i < currentLevel.Sligs.Count; i++)
                    {
                        if (!Abe.SLIGS.Contains(currentLevel.Sligs[i]))
                            currentLevel.Sligs[i].AI.CURRENT_STATE.RESET();
                    }
                    for (int i = 1; i < Abe.MUDOKONS.Count; i++)
                    {
                        if (Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITCOMMAND || Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITfOLLOW)
                            Abe.MUDOKONS[i].AI.CURRENT_STATE = Abe.MUDOKONS[i].AI.CLEANDOWN;
                    }
                }

                if (Abe.BoundigBox.Y >= 450)
                {
                    PAUSE = true;
                    if (currentLevel.NextDOWN == null)
                    {
                        currentLevel.NextDOWN = getNextLvl(currentLevel, GetNextCompLevels(currentLevel, "DOWN"));
                        currentLevel.NextDOWN.NextUP = currentLevel;
                    }

                    Abe.boundingBox.Y -= 400;
                    Abe.DrawingRec.Y -= 400;

                    ResetVideos(Abe, currentLevel.NextDOWN);

                    for (int i = 0; i < Abe.SLIGS.Count; i++)
                    {
                        if (!Abe.SLIGS.Contains(Abe.SLIGS[i]))
                            Abe.SLIGS[i].AI.CURRENT_STATE.RESET();
                    }
                    for (int i = 1; i < Abe.MUDOKONS.Count; i++)
                    {
                        if (Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITCOMMAND || Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITfOLLOW)
                            Abe.MUDOKONS[i].AI.CURRENT_STATE = Abe.MUDOKONS[i].AI.CLEANDOWN;
                    }
                    PAUSE = false;
                }

                if (Abe.BoundigBox.Y < 0)
                {
                    PAUSE = true;
                    if (currentLevel.NextUP == null)
                    {
                        currentLevel.NextUP = getNextLvl(currentLevel, GetNextCompLevels(currentLevel, "UP"));
                        currentLevel.NextUP.NextDOWN = currentLevel;
                    }

                    Abe.boundingBox.Y += 400;
                    Abe.DrawingRec.Y += 400;

                    ResetVideos(Abe, currentLevel.NextUP);

                    for (int i = 0; i < Abe.SLIGS.Count; i++)
                    {
                        if (!Abe.SLIGS.Contains(Abe.SLIGS[i]))
                            Abe.SLIGS[i].AI.CURRENT_STATE.RESET();
                    }
                    for (int i = 1; i < Abe.MUDOKONS.Count; i++)
                    {
                        if (Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITCOMMAND || Abe.MUDOKONS[i].AI.CURRENT_STATE == Abe.MUDOKONS[i].AI.WAITfOLLOW)
                            Abe.MUDOKONS[i].AI.CURRENT_STATE = Abe.MUDOKONS[i].AI.CLEANDOWN;
                    }
                    PAUSE = false;
                }

                if (abeCONTROL.DOORENTERED)
                {
                    Level prevLevel = currentLevel;
                    PAUSE = true;
                    Collision CurrentDoor = null;

                    if (abeCONTROL.DOOR.LINKEDLEVEL == null)
                    {
                        abeCONTROL.DOOR.LINKEDLEVEL = getNextLvl(currentLevel, GetNextCompLevels(currentLevel, "DOOR"));


                    }
                    ResetVideos(Abe, abeCONTROL.DOOR.LINKEDLEVEL);

                    foreach (List<Collision> collGroup in currentLevel.COLLISIONGROUPS)
                    {
                        foreach (Collision coll in collGroup)
                        {
                            if (coll.TYPE == COLLISIONS.DOOR)
                            {
                                CurrentDoor = coll;
                                CurrentDoor.LINKEDLEVEL = prevLevel;
                            }
                        }
                    }

                    Abe.boundingBox.X = CurrentDoor.REC.X - 7;
                    Abe.DrawingRec.X = CurrentDoor.REC.X - 31;

                    for (int i = 1; i < Abe.MUDOKONS.Count; i++)//ActiveMudokons
                    {

                        Mudokon mud = (Mudokon)Abe.MUDOKONS[i];
                        mud.AI.CURRENT_STATE = mud.AI.WAIT;
                        mud.CurrentAnimation = mud.WAIT;
                        mud.boundingBox.X = Abe.boundingBox.X;
                        mud.DrawingRec.X = Abe.DrawingRec.X;
                        mud.Direction = Abe.Direction;
                        mud.AI.CURRENT_STATE = mud.AI.WAIT;
                        prevLevel.RemoveMudokon(mud);
                        abeCONTROL.DOOR.LINKEDLEVEL.AddMudokon(mud);
                    }
                    PAUSE = false;
                    abeCONTROL.DOORENTERED = false;
                } 
                #endregion

                //Gestione uscita dal livello corrente (Mudokon)
                #region MudokonChangeLevel
                for (int i = 1; i < Abe.MUDOKONS.Count; i++)//ActiveMudokons
                {
                    Mudokon m = (Mudokon)Abe.MUDOKONS[i];
                    try
                    {
                        if (m.boundingBox.X >= 640 & m.CurrentAnimation.LastFrameDone)
                        {
                            m.CurrentLevel.RemoveMudokon(m);
                            m.CurrentLevel.NextRIGHT.AddMudokon(m);


                            m.boundingBox.X = 6;
                            m.DrawingRec.X -= 640 + 5;
                        }
                    }
                    catch (Exception MudokonLevelRightNull)
                    {
                        if (m != null)
                        {
                            m.CurrentLevel.AddMudokon(m);
                            m.boundingBox.X -= 43;
                            m.DrawingRec.X -= 43;
                            m.AI.CURRENT_STATE = m.AI.CLEANDOWN;
                        }
                    }
                    try
                    {
                        if (m.boundingBox.X < 6 & m.CurrentAnimation.LastFrameDone)
                        {
                            m.CurrentLevel.RemoveMudokon(m);
                            m.CurrentLevel.NextLEFT.AddMudokon(m);
                            m.boundingBox.X = 6 + 43 * 14;
                            m.DrawingRec.X += 640 + 5;

                        }
                    }
                    catch (Exception MudokonLevelLeftNull)
                    {
                        if (m != null)
                        {
                            m.CurrentLevel.AddMudokon(m);
                            m.boundingBox.X += 43;
                            m.DrawingRec.X += 43;
                            m.AI.CURRENT_STATE = m.AI.CLEANDOWN;
                        }
                    }

                    if (m.boundingBox.Y >= 450)
                    {
                        m.CurrentLevel.RemoveMudokon(m);
                        m.CurrentLevel.NextDOWN.AddMudokon(m);
                        m.boundingBox.Y -= 400;
                        m.DrawingRec.Y -= 400;

                    }

                    if (m.BoundigBox.Y < 0)
                    {
                        m.CurrentLevel.RemoveMudokon(m);
                        m.CurrentLevel.NextUP.AddMudokon(m);
                        m.boundingBox.Y += 400;
                        m.DrawingRec.Y += 400;
                    }
                } 
                #endregion

                //Gestione uscita dal livello corrente (SligControl)
                //Se uno Slig controllato dal giocatore esce dal livello corrente ne viene generato uno nuovo.
                #region SligControlChangeLevel
                if (abeCONTROL.sligToControl != null)
                {
                    if (abeCONTROL.sligToControl.boundingBox.X >= 640 & abeCONTROL.sligToControl.CurrentAnimation.LastFrameDone)
                    {
                        if (currentLevel.NextRIGHT == null)
                        {
                            currentLevel.NextRIGHT = getNextLvl(currentLevel, GetNextCompLevels(currentLevel, "RIGHT"));
                            currentLevel.NextRIGHT.NextLEFT = currentLevel;
                        }
                        abeCONTROL.sligToControl.boundingBox.X = 7;
                        abeCONTROL.sligToControl.DrawingRec.X -= 640 + 5;
                        currentLevel.Sligs.Remove(abeCONTROL.sligToControl);
                        ResetVideos(abeCONTROL.sligToControl, currentLevel.NextRIGHT);
                        currentLevel.Sligs.Add(abeCONTROL.sligToControl);
                    }
                    if (abeCONTROL.sligToControl.boundingBox.X < 6 & abeCONTROL.sligToControl.CurrentAnimation.LastFrameDone)
                    {
                        if (currentLevel.NextLEFT == null)
                            currentLevel.NextLEFT = getNextLvl(currentLevel, GetNextCompLevels(currentLevel, "LEFT"));

                        abeCONTROL.sligToControl.boundingBox.X = 7 + 43 * 14;
                        abeCONTROL.sligToControl.DrawingRec.X += 640 + 5;

                        currentLevel.Sligs.Remove(abeCONTROL.sligToControl);

                        ResetVideos(abeCONTROL.sligToControl, currentLevel.NextLEFT);

                        currentLevel.Sligs.Add(abeCONTROL.sligToControl);
                    }
                } 
                #endregion

                //Gestione uscita dal livello corrente (Slig)
                #region SligChangeLevel
                for (int i = 0; i < Abe.SLIGS.Count; i++)
                {
                    if (Abe.SLIGS.Count > 0 && Abe.SLIGS[i].boundingBox.X >= 640 & Abe.SLIGS[i].CurrentAnimation.LastFrameDone)
                    {
                        Abe.SLIGS[i].CurrentLevel.RemoveSlig(Abe.SLIGS[i]);
                        Abe.SLIGS[i].CurrentLevel.NextRIGHT.AddSlig(Abe.SLIGS[i]);
                        Abe.SLIGS[i].boundingBox.X = 7;
                        Abe.SLIGS[i].DrawingRec.X -= 640 + 5;


                        if (Abe.SLIGS[i].AI.CURRENT_STATE == Abe.SLIGS[i].AI.GOBACKHOME2)
                            Abe.SLIGS[i].AI.CURRENT_STATE = Abe.SLIGS[i].AI.SENTINELLA;
                        if (Abe.SLIGS[i].AI.CURRENT_STATE == Abe.SLIGS[i].AI.GOBACKHOME)
                            Abe.SLIGS[i].AI.CURRENT_STATE.RESET();
                    }
                    if (Abe.SLIGS.Count > 0 && Abe.SLIGS[i].boundingBox.X < 6 & Abe.SLIGS[i].CurrentAnimation.LastFrameDone)
                    {
                        Abe.SLIGS[i].CurrentLevel.RemoveSlig(Abe.SLIGS[i]);
                        Abe.SLIGS[i].CurrentLevel.NextLEFT.AddSlig(Abe.SLIGS[i]);
                        Abe.SLIGS[i].boundingBox.X = 7 + 43 * 14;
                        Abe.SLIGS[i].DrawingRec.X += 640 + 5;


                        if (Abe.SLIGS[i].AI.CURRENT_STATE == Abe.SLIGS[i].AI.GOBACKHOME2)
                            Abe.SLIGS[i].AI.CURRENT_STATE = Abe.SLIGS[i].AI.SENTINELLA;
                        if (Abe.SLIGS[i].AI.CURRENT_STATE == Abe.SLIGS[i].AI.GOBACKHOME)
                            Abe.SLIGS[i].AI.CURRENT_STATE.RESET();

                    }
                } 
                #endregion

                //Gestione Input per sistema di controllo
                #region ManageInputControl
                if (Keyboard.GetState().IsKeyUp(Keys.D1))
                {
                    OneDown = false;
                }

                if (Keyboard.GetState().IsKeyDown(Keys.D1))//HELLO
                {
                    OneDown = true;
                }

                if (Keyboard.GetState().IsKeyUp(Keys.D2))
                {
                    TwoDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.D2))//FOLLOW
                {
                    TwoDown = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.D4))
                {
                    FourDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.D4))//COMMANDJUMP
                {
                    FourDown = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.D3))
                {
                    ThreeDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.D3))//WAITME
                {
                    ThreeDown = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.D0))
                {
                    ZeroDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.D0))//OMM
                {
                    ZeroDown = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.Z))
                {
                    zetaDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.Z))//ZETA
                {
                    zetaDown = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.LeftControl))
                {
                    CTRLDown = false;
                    FirstCTRLDown = true;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.LeftControl) & FirstCTRLDown)//CTRL
                {
                    FirstCTRLDown = false;
                    CTRLDown = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.Right) & rightDown)////UP RIGHT
                {
                    rightDown = false;
                    rightDownSlig = false;
                    if (OnepassSligg <= 100f & OnepassSligg > 0f)
                        OnerightDownSlig = true;

                    OnepassSligg = 0f;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.Right))////DOWN RIGHT
                {
                    rightDown = true;
                    OnerightDownSlig = false;
                    if (abeCONTROL.sligToControl != null)
                        OnepassSligg += deltaTime2;

                    if (OnepassSligg > 100f)
                        rightDownSlig = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.Left) & leftDown)////UP LEFT
                {
                    leftDown = false;
                    leftDownSlig = false;
                    if (OnepassSligg <= 100f & OnepassSligg > 0f)
                        OneleftDownSlig = true;

                    OnepassSligg = 0f;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.Left))////DOWN LEFT
                {
                    leftDown = true;

                    OneleftDownSlig = false;
                    if (abeCONTROL.sligToControl != null)
                        OnepassSligg += deltaTime2;

                    if (OnepassSligg > 100f)
                        leftDownSlig = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.Up) & upDown)////UP UP
                {
                    upDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.Up))////DOWN UP
                {
                    upDown = true;
                }

                if (Keyboard.GetState().IsKeyUp(Keys.Down) & downDown)////UP DOWN
                {
                    downDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.Down))////DOWN DOWN
                {
                    downDown = true;
                }

                if (Keyboard.GetState().IsKeyUp(Keys.Space) & spaceDown)////UP SPACE
                {
                    Abe.CanMove = false;
                    spaceDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.Space))////DOWN SPACE
                {
                    spaceDown = true;
                }

                if (Keyboard.GetState().IsKeyUp(Keys.LeftShift) & shiftDown)////UP SHIFT
                {
                    shiftDown = false;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.LeftShift))
                {
                    shiftDown = true;
                }

                if (Keyboard.GetState().IsKeyDown(Keys.LeftAlt))
                {
                    altDown = true;
                }
                if (Keyboard.GetState().IsKeyUp(Keys.LeftAlt) & altDown)////UP ALT
                {
                    altDown = false;
                } 
                #endregion
                
            }

            if (!PAUSE & !SHOW_REPORT)//Se il gioco non  in pausa e il percorso non  finito
            {
                abeCONTROL.ROUTINE();//Sistema di controllo[pp.48,49]

                //Esegue gli automi definiti nelle rispettive classi
                #region SligAI
                for (int i = 0; i < currentLevel.Sligs.Count; i++)
                {
                    if (!Abe.SLIGS.Contains(currentLevel.Sligs[i]))
                        currentLevel.Sligs[i].AI.ROUTINE();
                }

                for (int i = 0; i < Abe.SLIGS.Count; i++)
                {
                    Abe.SLIGS[i].AI.ROUTINE();
                } 
                #endregion

                #region MudokonAI
                for (int i = 0; i < currentLevel.Mudokons.Count; i++)
                {
                    if (!Abe.MUDOKONS.Contains(currentLevel.Mudokons[i]))
                        currentLevel.Mudokons[i].AI.ROUTINE();
                }

                for (int i = 1; i < Abe.MUDOKONS.Count; i++)//i==0 is Abe!
                {
                    Mudokon m = (Mudokon)Abe.MUDOKONS[i];
                    m.AI.ROUTINE();
                } 
                #endregion

                #region ObjectAControl
                foreach (ObjectA OBJ in currentLevel.ObjectsA)
                {
                    OBJ.objControl.ROUTINE();
                } 
                #endregion
                ////////////////////////////////////////////////////
            }

            if (SHOW_REPORT)//Se il percorso  finito
                REPORT.Control();//Gestione sondaggio finale[pp.76,77]

            #region WindowTitle
            if (abeCONTROL.CURRENT_STATE.name != "DIED")
            {
                //for (int i = 1; i < Abe.MUDOKONS.Count; i++)
                //    Window.Title = Abe.MUDOKONS[i].AI.CURRENT_STATE.name;
                foreach(Mudokon m in currentLevel.Mudokons )
                    Window.Title = m.AI.CURRENT_STATE.name + "  " + m.CurrentAnimation.Name + "   " + m.CurrentAnimation.CurrentFrame;
            } 
            #endregion

        }

        //Disegna tutti gli elementi della scena
        //[p.22]
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.White);

            if (!SHOW_REPORT)//Se il percorso non  finito
            {
                #region DrawBackground
                if (drawBack)
                {
                    if (!Debug)
                    {
                        spriteBatch.Begin();
                        spriteBatch.Draw(CurrentLevel.BackGround, backRec, null, Color.White);
                        spriteBatch.End();
                    }
                } 
                #endregion

                #region DrawVideos
                for (int i = 0; i < currentLevel.VIDEOS.Count; i++)
                {
                    if (currentLevel.VIDEOS[i].IsPlaying)
                    {
                        spriteBatch.Begin();
                        spriteBatch.Draw(currentLevel.VIDEOS[i].CurrentTexture, currentLevel.VIDEOSREC[i], new Rectangle(0, 0, currentLevel.VIDEOSREC[i].Width, currentLevel.VIDEOSREC[i].Height), Color.White);
                        spriteBatch.End();
                    }
                } 
                #endregion

                #region DrawObjectA
                spriteBatch.Begin();
                foreach (ObjectA OBJ in currentLevel.ObjectsA)
                {
                    if (OBJ.CurrentAnimation.Sheet != null & OBJ.objControl.CURRENT_STATE != OBJ.objControl.INVISIBLE)
                        spriteBatch.Draw(OBJ.CurrentAnimation.Sheet, OBJ.DrawingRec, OBJ.CurrentAnimation.SourceRect, Color.White);
                }
                spriteBatch.End(); 
                #endregion

                #region DrawMudokon
                spriteBatch.Begin();
                foreach (Mudokon mudokon in currentLevel.Mudokons)
                {
                    if (mudokon.AI.CURRENT_STATE != mudokon.AI.DIED)
                        spriteBatch.Draw(mudokon.CurrentAnimation.Sheet, mudokon.DrawingRec, mudokon.CurrentAnimation.SourceRect, mudokon.color);
                }
                spriteBatch.End(); 
                #endregion

                #region DrawAbe
                if (abeCONTROL.sligToControl == null || (abeCONTROL.sligToControl != null && abeCONTROL.sligToControl.CurrentLevel == Abe.CurrentLevel))
                {
                    spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
                    spriteBatch.Draw(Abe.CurrentAnimation.Sheet, Abe.DrawingRec, Abe.CurrentAnimation.SourceRect, Abe.color);
                    spriteBatch.End();
                } 
                #endregion

                #region DrawSlig
                spriteBatch.Begin();
                foreach (Slig SLIG in currentLevel.Sligs)
                {
                    spriteBatch.Draw(SLIG.CurrentAnimation.Sheet, SLIG.DrawingRec, SLIG.CurrentAnimation.SourceRect, SLIG.color);
                }
                spriteBatch.End(); 
                #endregion

                #region DrawObject
                spriteBatch.Begin();
                if (currentLevel.OBJECTS != null)
                    spriteBatch.Draw(currentLevel.OBJECTS, backRec, null, Color.White);
                spriteBatch.End(); 
                #endregion

                #region DebugView
                if (Debug)
                {
                    spriteBatch.Begin();

                    foreach (Slig SLIG in currentLevel.Sligs)
                    {
                        spriteBatch.Draw(SLIG.SLIG_BBOX_PNG, SLIG.BoundigBox, null, Color.White);
                        spriteBatch.Draw(SLIG.SLIG_BBOX_PNG, SLIG.SligEye, null, Color.White);
                    }
                    foreach (Mudokon MUD in currentLevel.Mudokons)
                        spriteBatch.Draw(MUD.MUDOKON_BBOX_PNG, MUD.boundingBox, null, Color.White);

                    spriteBatch.Draw(Abe.ABE_BBOX_PNG, Abe.BoundigBox, null, Color.White);

                    spriteBatch.End();
                } 
                #endregion
            }
            else 
            {
                #region DrawSurvey
                spriteBatch.Begin();
                spriteBatch.Draw(REPORT.BackGround, backRec, null, Color.White);
                spriteBatch.End();

                spriteBatch.Begin();
                spriteBatch.Draw(REPORT.LEVELS[REPORT.LVL_INDEX].BackGround, REPORT.DrawRecLvl, null, Color.White);
                spriteBatch.End(); 
                #endregion

            }
            base.Draw(gameTime);
        }
     
        //Dato il livello corrente e la direzione di uscita
        //restituisce una lista contenente i livelli strutturalmente compatibili
        //[p.73]
        List<Level> GetNextCompLevels(Level lvl, string Direction)
        {
            foreach (Level comp in LevelMaker.lvlList)
            {
                if (comp.Enviorement != lvl.Enviorement)
                {
                    switch (Direction)
                    {
                        case "RIGHT":
                            if (lvl.BLOCCOUPRight == comp.BLOCCOUPLeft && lvl.FLOOR2NDRight == comp.FLOOR2NDLeft && lvl.BLOCCODOWNRight == comp.BLOCCODOWNLeft)
                                lvl.compatibleLevels.Add(new Level(comp));
                            break;

                        case "LEFT":
                            if (lvl.BLOCCOUPLeft == comp.BLOCCOUPRight && lvl.FLOOR2NDLeft == comp.FLOOR2NDRight && lvl.BLOCCODOWNLeft == comp.BLOCCODOWNRight)
                                lvl.compatibleLevels.Add(new Level(comp));
                            break;

                        case "DOWN":
                            int HoistsLvlDown = 0;
                            int HoistsCompDown = 0;
                            foreach (List<Collision> collGroup in lvl.COLLISIONGROUPS)
                                foreach (Collision coll in collGroup)
                                    if ((coll.TYPE == COLLISIONS.HOISTDESTRO || coll.TYPE == COLLISIONS.HOISTSINISTRO) & coll.REC.Y == 385)
                                    {
                                        HoistsLvlDown++;
                                        foreach (List<Collision> collGroupComp in comp.COLLISIONGROUPS)
                                            foreach (Collision collComp in collGroupComp)
                                                if ((collComp.TYPE == COLLISIONS.HOISTDESTRO || collComp.TYPE == COLLISIONS.HOISTSINISTRO) & collComp.REC.Y == -15 & coll.REC.X == collComp.REC.X)
                                                    HoistsCompDown++;
                                    }

                            if (HoistsLvlDown == HoistsCompDown)
                                lvl.compatibleLevels.Add(new Level(comp));
                            break;

                        case "UP":
                            int HoistsLvlUp = 0;
                            int HoistsCompUp = 0;
                            foreach (List<Collision> collGroup in lvl.COLLISIONGROUPS)
                                foreach (Collision coll in collGroup)
                                    if ((coll.TYPE == COLLISIONS.HOISTDESTRO || coll.TYPE == COLLISIONS.HOISTSINISTRO) & coll.REC.Y == -15)
                                    {
                                        HoistsLvlUp++;
                                        foreach (List<Collision> collGroupComp in comp.COLLISIONGROUPS)
                                            foreach (Collision collComp in collGroupComp)
                                                if ((collComp.TYPE == COLLISIONS.HOISTDESTRO || collComp.TYPE == COLLISIONS.HOISTSINISTRO) & collComp.REC.Y == 385 & coll.REC.X == collComp.REC.X)
                                                    HoistsCompUp++;
                                    }

                            if (HoistsCompUp == HoistsLvlUp)
                                lvl.compatibleLevels.Add(new Level(comp));
                            break;

                        case "DOOR":
                            foreach (List<Collision> collGroup in comp.COLLISIONGROUPS)
                            {
                                foreach (Collision coll in collGroup)
                                {
                                    if (coll.TYPE == COLLISIONS.DOOR)
                                    {
                                        Level newCopy = new Level(comp);
                                        lvl.compatibleLevels.Add(newCopy);
                                    }
                                }
                            }
                            break;
                    }
                }
            }          
            return lvl.compatibleLevels;
        }

        #region GetCompLvls2
        List<Level> getCompLvls(Level lvl)
        {
            foreach (Level comp in LevelMaker.lvlList)
            {
                if (lvl.NAME != comp.NAME)
                {
                    if (!abeCONTROL.DOORENTERED)
                    {
                        if (!lvl.FLOOR2NDLeft & !lvl.FLOOR2NDRight || lvl.FLOOR2NDLeft)
                        {
                            if ((!comp.FLOOR2NDLeft & !comp.FLOOR2NDRight || !comp.FLOOR2NDLeft & comp.FLOOR2NDRight)
                                & !comp.BLOCCODOWNLeft)
                            {
                                Level newCopy = new Level(comp);
                                lvl.compatibleLevels.Add(newCopy);
                            }
                        }

                        if ((!lvl.FLOOR2NDLeft & lvl.FLOOR2NDRight || lvl.FLOOR2NDLeft & lvl.FLOOR2NDRight)
                            & !lvl.BLOCCODOWNRight & !lvl.BLOCCOUPRight)
                        {
                            if ((comp.FLOOR2NDLeft & comp.FLOOR2NDRight || comp.FLOOR2NDLeft & !comp.FLOOR2NDRight)
                                & !comp.BLOCCODOWNLeft & !comp.BLOCCOUPLeft)
                            {
                                Level newCopy = new Level(comp);
                                lvl.compatibleLevels.Add(newCopy);
                            }
                        }

                        if ((!lvl.FLOOR2NDLeft & lvl.FLOOR2NDRight || lvl.FLOOR2NDLeft & lvl.FLOOR2NDRight)
                            & lvl.BLOCCODOWNRight)
                        {
                            if ((comp.FLOOR2NDLeft & comp.FLOOR2NDRight || comp.FLOOR2NDLeft & !comp.FLOOR2NDRight)
                                & comp.BLOCCODOWNLeft & !comp.BLOCCOUPLeft)
                            {
                                Level newCopy = new Level(comp);
                                lvl.compatibleLevels.Add(newCopy);
                            }
                        }
                    }
                    else
                    {
                        foreach (List<Collision> collGroup in comp.COLLISIONGROUPS)
                        {
                            foreach (Collision coll in collGroup)
                            {
                                if (coll.TYPE == COLLISIONS.DOOR)
                                {
                                    Level newCopy = new Level(comp);
                                    lvl.compatibleLevels.Add(newCopy);
                                }
                            }
                        }
                    }
                }
            }

            return lvl.compatibleLevels;
        } 
        #endregion

        //Dato il livello corrente e la lista dei livelli compatibili
        //restituisce un livello con grado di difficolt opportuno
        //[p.74]
        Level getNextLvl(Level lvl,List<Level> compLvls)
        {
            Random random = new Random();
            List<Level> lvlsNext = new List<Level>();
            int rand;
            int Range = 1;
            bool found = false;
            int lvlsDifference;
            Level NextLevel = currentLevel;
            

            if (NUMLVLGEN < MAXlvls)
            {
                while (!found)
                {
                    Range++;
                    for (int i = 0; i < compLvls.Count; i++)
                    {
                        lvlsDifference = Math.Abs(lvl.difficult - compLvls[i].difficult);

                        if (lvlsDifference <= Range)
                        {
                            lvlsNext.Add(compLvls[i]);
                            found = true;

                            foreach (Level lvlVisited in REPORT.LEVELS)
                            {
                                if (i < compLvls.Count && lvlVisited.Enviorement == compLvls[i].Enviorement)
                                {
                                    lvlsNext.Remove(compLvls[i]);
                                    compLvls.Remove(compLvls[i]);
                                    found = false;
                                }
                            }
                        }
                    }
                }
                rand = random.Next(0, lvlsNext.Count);
                NextLevel = lvlsNext[rand];
                NUMLVLGEN++;
                REPORT.LEVELS.Add(NextLevel);
            }
            else
                SHOW_REPORT = true;

            compLvls.Clear();
            
            return NextLevel;
        }

        public void ResetVideos(Character currentChar, Level nextLvl)
        {
            foreach (Video vid in currentLevel.VIDEOS)
                vid.Stop();

            currentLevel = nextLvl;
            currentChar.CurrentLevel = currentLevel;

            foreach (Video vid in currentLevel.VIDEOS)
                vid.Play();
        }

        #region Attribute
        public Level CurrentLevel
        {
            get { return currentLevel; }
            set { currentLevel = value; }
        }
        public static Level getLevel(string enviorement)
        {
            foreach (Level lvl in LevelMaker.lvlList)
            {
                if (lvl.Enviorement == enviorement)
                    return lvl;
            }

            return null;
        }
        #endregion
        
    }
}
